unit MyProc;

interface

uses SysUtils, Math;

function  PadC(Text: string; Count: Word; Character: Char): string;
function  PadL(Text: string; Count: Word; Character: Char): string;
function  PadR(Text: string; Count: Word; Character: Char): string;
function  LeftStr(Text: string; Count: Word): string;
function  Right(Text: string; Count: Word): string;
function  FindChar(Text: String; Symbol: Char; N: Byte): Integer;
function  CountChar(Text: String; Ch: Char): Integer;
function  CharCount(Znak: Char; Count: Integer): string;
function  MinusStr(Text1, Text2: string): string;
function  IifInt(Podminka: Boolean; Value1, Value2: Integer): Integer;
function  IifStr(Podminka: Boolean; Value1, Value2: string): string;
function  CodeString(Text, Code: string): string;
function  DecodeString(Text, Code: string): string;
function  SqrX(Value: Extended; Count: Integer): Extended;
function  Question(Text: string): Boolean;
function  StrToInteger(Text: string): Integer;
function  AbsInt(Value: Integer): Integer;
function  InsertStrRight(SourceText, InsertText: string; Position: Integer): string;
function  InsertStrLeft(SourceText, InsertText: string; Position: Integer): string;
function  YearOfDate(xDate: TDateTime): Word;
function  MonthOfDate(xDate: TDateTime): Word;
function  DayOfDate(xDate: TDateTime): Word;
function  AddSlash(Text: string): string;
function  IsKeyDown(VirtualKey: Integer): Boolean;
function  DPH(Cena, Procenta: Currency; Typ: Char): Real;
function  IsInSeason(Year, Month, YearMin, MonthMin, YearMax, MonthMax: Integer): Boolean;
procedure Waiting(Delay: Integer);

implementation

uses  Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, Buttons;

function  PadC(Text: string; Count: Word; Character: Char): string;
begin
  Result:=Copy(CharCount(Character,Count div 2)+Text+CharCount(Character,(Count div 2)+(Count mod 2)),(Length(CharCount(Character,Count div 2)+Text+CharCount(Character,(Count div 2)+(Count mod 2))) div 2)-(Count div 2),Count);
end;

function  PadL(Text: string; Count: Word; Character: Char): string;
begin
  Result:=Right(CharCount(Character,Count)+Text,Count);
end;

function  PadR(Text: string; Count: Word; Character: Char): string;
begin
  Result:=LeftStr(Text+CharCount(Character,Count),Count);
end;

function  LeftStr(Text: string; Count: Word): string;
begin
  Result:=Copy(Text,1,Count);
end;

function  Right(Text: string; Count: Word): string;
begin
  Result:=Copy(Text,Length(Text)-(Count-1),Count);
end;

function  FindChar(Text: String; Symbol: Char; N: Byte): Integer;
var i, j: Integer;
begin
  J:=0;
  for i:=1 to Length(Text) do
    begin
    if Text[i]=Symbol then j:=j+1;
    if j=N then
      begin
      FindChar:=i;
      Exit;
      end;
    end;
  FindChar:=Length(Text);
end;

function  CountChar(Text: String; Ch: Char): Integer;
var i,j: Integer;
begin
  j:=0;
  for i:=1 to Length(Text) do if Text[i]=Ch then Inc(j);
  CountChar:=j;
end;

function CharCount(Znak: Char; Count: Integer): string;
var i: Integer;
begin
  Result:='';
  for i:=1 to Count do Result:=Result+Znak;
end;

function  MinusStr(Text1, Text2: string): string;
var i: Integer;
begin
  for i:=1 to Length(Text2) do
    if Text1[i]<>Text2[i] then
      begin
      Result:=Copy(Text1,i,Length(Text1)-i+1);
      Exit;
      end;
  Result:=Copy(Text1,Length(Text2)+1,Length(Text1)-Length(Text2)+2);
end;

function IifInt(Podminka: Boolean; Value1, Value2: Integer): Integer;
begin
  if Podminka then IifInt:=Value1 else IifInt:=Value2;
end;

function IifStr(Podminka: Boolean; Value1, Value2: string): string;
begin
  if Podminka then IifStr:=Value1 else IifStr:=Value2;
end;

function CodeString(Text, Code: string): string;
var i, ic, temp: Integer;
    tmpText: string;
begin
  ic:=1;
  tmpText:='';
  Code:=Trim(Code);
  for i:=1 to Length(Text) do
    begin
    temp:=Ord(Text[i])+(Ord(Code[ic])-48);
    tmpText:=tmpText+Chr(IifInt(temp>255,temp-256,temp));
    if ic>=Length(Code) then ic:=1 else Inc(ic);
    end;
  Result:=tmpText;
end;

function DecodeString(Text, Code: string): string;
var i, ic, temp: Integer;
    tmpText: string;
begin
  ic:=1;
  tmpText:='';
  Code:=Trim(Code);
  for i:=1 to Length(Text) do
    begin
    temp:=Ord(Text[i])-(Ord(Code[i])-48);
    tmpText:=tmpText+Chr(IifInt(temp>255,temp-256,temp));
    if ic>=Length(Code) then ic:=1 else Inc(ic);
    end;
  Result:=tmpText;
end;

function  SqrX(Value: Extended; Count: Integer): Extended;
var i: Integer;
begin
  if Count=0 then Result:=1
  else
    begin
    Result:=Value;
    for i:=1 to Count-1 do Result:=Result*Value;
    end;
end;

function  Question(Text: string): Boolean;
var tmpForm: TForm;
    tmpButton1, tmpButton2: TBitBtn;
    tmpLabel: TLabel;
begin
  tmpForm:=TForm.Create(nil);
  tmpForm.Width:=300;
  tmpForm.Height:=100;
  tmpForm.Caption:='';
  tmpForm.BorderStyle:=bsToolWindow;
  tmpForm.Left:=(Screen.Width div 2)-(tmpForm.Width div 2);
  tmpForm.Top:=(Screen.Height div 2)-(tmpForm.Height div 2);
  tmpButton1:=TBitBtn.Create(tmpForm);
  tmpButton1.Parent:=tmpForm;
  tmpButton1.Kind:=bkOK;
  tmpButton1.Caption:='&Ano';
  tmpButton1.Top:=45;
  tmpButton2:=TBitBtn.Create(tmpForm);
  tmpButton2.Parent:=tmpForm;
  tmpButton2.Kind:=bkCancel;
  tmpButton2.Caption:='&Ne';
  tmpButton2.Top:=45;
  tmpLabel:=TLabel.Create(tmpForm);
  tmpLabel.Parent:=tmpForm;
  tmpLabel.Caption:=Text;
  tmpLabel.Left:=20;
  tmpLabel.Top:=10;
  tmpForm.Width:=IifInt((tmpLabel.Width+50)<300,300,tmpLabel.Width+50);
  tmpButton1.Left:=(tmpForm.Width div 2)-90;
  tmpButton2.Left:=(tmpForm.Width div 2)+15;
  Result:=tmpForm.ShowModal=mrOk;
end;

function  StrToInteger(Text: string): Integer;
var i: Integer;
    tmp, tmp1: string;
begin
  tmp:=Trim(Text);
  tmp1:='';
  for i:=1 to Length(tmp) do
    if ((tmp[i]>='0') and (tmp[i]<='9')) or ((tmp[i]='-') and (i=1)) then
      tmp1:=tmp1+tmp[i] else Break;
  if (tmp1='') or (tmp1='-') then Result:=0 else Result:=StrToInt(tmp1);
end;

function  AbsInt(Value: Integer): Integer;
begin
  Result:=Value*IifInt(Value<0,-1,1);
end;

function  InsertStrRight(SourceText, InsertText: string; Position: Integer): string;
begin
  Result:=Copy(SourceText,1,Length(SourceText)-Position)+InsertText+Right(SourceText,Position);
end;

function  InsertStrLeft(SourceText, InsertText: string; Position: Integer): string;
begin
  Result:=Copy(SourceText,1,Position)+InsertText+Right(SourceText,Length(SourceText)-Position);
end;

function  YearOfDate(xDate: TDateTime): Word;
var tmpDay, tmpMonth, tmpYear: Word;
begin
  DecodeDate(xDate,tmpYear,tmpMonth,tmpDay);
  Result:=tmpYear
end;

function  MonthOfDate(xDate: TDateTime): Word;
var tmpDay, tmpMonth, tmpYear: Word;
begin
  DecodeDate(xDate,tmpYear,tmpMonth,tmpDay);
  Result:=tmpMonth
end;

function  DayOfDate(xDate: TDateTime): Word;
var tmpDay, tmpMonth, tmpYear: Word;
begin
  DecodeDate(xDate,tmpYear,tmpMonth,tmpDay);
  Result:=tmpDay
end;

function  AddSlash(Text: string): string;
begin
  if (Length(Text)=0) or (Text[Length(Text)]='\') then Result:=Text else Result:=Text+'\';
end;

function  IsKeyDown(VirtualKey: Integer): Boolean;
begin
  Result:=(GetKeyState(VirtualKey) and 128)=128;
end;

function  DPH(Cena, Procenta: Currency; Typ: Char): Real;
begin
  Result:=0;
  case Typ of
    'D': Result:=Ceil(Round(Cena*(Procenta/(Procenta+100))*100)/10)/10;
    'Z': Result:=Cena-Ceil(Round(Cena*(Procenta/(Procenta+100))*100)/10)/10;
    end;
end;

function  IsInSeason(Year, Month, YearMin, MonthMin, YearMax, MonthMax: Integer): Boolean;
begin
  Result:=False;
  if YearMin=0 then
    begin
    if YearMax=0 then
      begin
      if Year<=YearMax then Result:=True;
      end
    else
      begin
      if (Year<=YearMax) and (Month<=MonthMax) then Result:=True;
      end;
    end
  else
    begin
    if YearMax=0 then
      begin
      if MonthMax=0 then
        begin
        if Year>=YearMin then Result:=True;
        end
      else
        begin
        if (Year>=YearMin) and (Month>=MonthMin) then Result:=True;
        end;
      end
    else
      begin
      if MonthMax=0 then
        begin
        if MonthMin=0 then
          begin
          if (Year>=YearMin) and (Year<=YearMax) then Result:=True;
          end
        else
          begin
          if (Year>=YearMin) and (Year<=YearMax) and (Month>=MonthMin) then Result:=True;
          end;
        end
      else
        begin
        if MonthMin=0 then
          begin
          if (Year>=YearMin) and (Year<=YearMax) and (Month<=MonthMax) then Result:=True;
          end
        else
          begin
          if (Year>=YearMin) and (Year<=YearMax) and (Month>=MonthMin) and (Month<=MonthMax) then Result:=True;
          end;
        end;
      end;
    end;
end;

procedure Waiting(Delay: Integer);
var tmpCas: Cardinal;
begin
  tmpCas:=GetCurrentTime;
  while tmpCas+Delay>GetCurrentTime do;
end;

end.

